﻿(function (root, factory) {
    if (typeof exports === 'object') { module.exports = factory(require('moment')); }
    else if (typeof define === 'function' && define.amd) { define('moment-range', ['moment'], factory); }
    else { root.moment = factory(root.moment); }
}(this, function (moment) {
    var DateRange; DateRange = (function () {
        function DateRange(start, end) { this.start = moment(start); this.end = moment(end); }
        DateRange.prototype.contains = function (moment) { return (this.start <= moment && moment <= this.end); }; DateRange.prototype._by_string = function (interval, hollaback) {
            var current, _results; current = moment(this.start); _results = []; while (this.contains(current)) { hollaback.call(this, current.clone()); _results.push(current.add(interval, 1)); }
            return _results;
        }; DateRange.prototype._by_range = function (range_interval, hollaback) {
            var i, l, _i, _results; l = Math.round(this / range_interval); if (l === Infinity) { return this; }
            _results = []; for (i = _i = 0; 0 <= l ? _i <= l : _i >= l; i = 0 <= l ? ++_i : --_i) { _results.push(hollaback.call(this, moment(this.start.valueOf() + range_interval.valueOf() * i))); }
            return _results;
        }; DateRange.prototype.overlaps = function (range) { return this.start < range.end && this.end > range.start; }; DateRange.prototype.by = function (range, hollaback) {
            if (typeof range === 'string') { this._by_string(range, hollaback); } else { this._by_range(range, hollaback); }
            return this;
        }; DateRange.prototype.valueOf = function () { return this.end - this.start; }; DateRange.prototype.toDate = function () { return [this.start.toDate(), this.end.toDate()]; }; return DateRange;
    })(); moment.fn.range = function (start, end) { if (['year', 'month', 'week', 'day', 'hour', 'minute', 'second'].indexOf(start) > -1) { return new DateRange(moment(this).startOf(start), moment(this).endOf(start)); } else { return new DateRange(start, end); } }; moment.fn.within = function (range) { return range.contains(this._d); }; return moment;
}));